/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008 <talsi.elderme@gmail.com>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

uniform vec3 hemiAxis;

attribute vec3 tangent;

varying vec3 hemiDir;


void main(void) {

	vec3 n = normalize(gl_NormalMatrix * gl_Normal);
	vec3 t = normalize(gl_NormalMatrix * tangent);
	vec3 b = cross(n, t);

	gl_Position = ftransform();
	gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	vec4 ecPosition  = gl_ModelViewMatrix * gl_Vertex;
	eyeDir = ecPosition.xyz;
	gl_FogFragCoord = length(ecPosition);

	fillDirAndDistArrays(t,b,n);

	vec3 v;
	v = -eyeDir;
	eyeDir.x = dot(v, t);
	eyeDir.y = dot(v, b);
	eyeDir.z = dot(v, n);


	hemiDir.x = dot(hemiAxis, t);
	hemiDir.y = dot(hemiAxis, b);
	hemiDir.z = dot(hemiAxis, n);
}



