/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MATERIALSHADER_H_
#define _MATERIALSHADER_H_

#include "shader.h"
#include "vector3.h"

class MaterialShader: public Shader 
{
public:
	MaterialShader(int nbLightsDir, int nbLightsSpot, int nbLightsPoint,
					   int nbColorMaps, int nbNormalMaps, int nbGlossMaps, int nbEmiMaps);
	
		
	void setLocations();

	int getLocationTangent();	
	
	int getNbColorMaps();
	int getLocationNbColorMaps();
	void setIdColorMap(int id);
	int getLocationColorMap();
		
	int getNbNormalMaps();		
	int getLocationNbNormalMaps();
	void setIdNormalMap(int id);
	int getLocationNormalMap();		
		
	int getNbGlossMaps();
	int getLocationNbGlossMaps();
	void setIdGlossMap(int id);
	int getLocationGlossMap();
		
	int getNbEmiMaps();
	int getLocationNbEmiMaps();		
	void setIdEmiMap(int id);
	int getLocationEmiMap();
				
		
	void setNumMaps(int color, int normal, int gloss, int emi);
		
	void setAmbientColors(Color groundColor, Color skyColor, Vector3 hemiAxis);	
		
	
protected:

	int locationTangent;	
	
	int locationGroundColor;
	int locationSkyColor;
		
	int locationHemiAxis;
		
	int mNbLightsDir;		
	int mNbLightsSpot;
	int mNbLightsPoint;
	
	int mNbColorMaps;
	int locationNbColorMaps;
	int locationColorMap;
		
	int mNbNormalMaps;
	int locationNbNormalMaps;	
	int locationNormalMap;
		
	int mNbGlossMaps;
	int locationNbGlossMaps;		
	int locationGlossMap;
		
	int mNbEmiMaps;
	int locationNbEmiMaps;
	int locationEmiMap;
		
	
};

#endif // _MATERIALSHADER_H_
