/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SHADERWRITER_H_
#define _SHADERWRITER_H_


#include <string>
#include <iostream>
#include <sstream>

class ShaderWriter
{
public:
	ShaderWriter();
	~ShaderWriter();
	
	void setNbMaps(int nbColorMaps, int nbNormalMaps, int nbGlossMaps, int nbEmiMaps);
	void setNbLights(int nbLightDir, int nbLightSpot, int nbLightPoint);

	std::string writeLightingVertexShaderSourceCode();		
		
	std::string writeMaterialFragmentShaderSourceCode();		
	
	std::string writeLightingFragmentShaderSourceCode();
		
	
protected:

	int mNbColorMaps;
	int mNbNormalMaps;
	int mNbGlossMaps;
	int mNbEmiMaps;
		
	int mNbLightDir;
	int mNbLightSpot;
	int mNbLightPoint;

};

#endif // _SHADERWRITER_H_
