/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "newtState.h"


NewtState::NewtState(std::string name, std::string dirName): mName(name), mDirPath(fileMana->getHomeNewtDir() + "/" + dirName), mQuit(false) {
	fileMana->initNewtStateDir(mDirPath);
	scene->setGraphicOptions(new GraphicOptions(mDirPath + "/specificGraphicOptions.dat"));
}

NewtState::~NewtState() {
	delete mKeyboardOptions;	
}

std::string NewtState::getName() {
	return mName;
}

KeyboardOptions* NewtState::getKeyboardOptions() {
	return mKeyboardOptions;
}

bool NewtState::haveToStopWastingTime() {
	return mQuit;
}


void NewtState::init() {
	initDisplayEnvironments();
	createObjects ();
	createLights ();
	scene->initObjectsAndShaders();	
}



